#!/usr/local/bin/perl

use Socket;
use Net::FTP;

print "Content-type: text/html\n\n";

&parse_form;

$FORM{files}=~s/\r//g;
@files=split ("\n", $FORM{files});

$ftp=Net::FTP->new ($FORM{host});
$ftp->login ($FORM{login}, $FORM{password});
$ftp->mkdir("$FORM{ftpdir}");


foreach $file (@files){
	$meth=substr ($file,0,4);
	if ($meth eq "http"){
		$url=$file;
		$url=~s /http:\/\///;
		($host,@get)=split ("/",$url);
		$dfile=$get[$#get];
		$get="/".join ("/", @get);
		#    http 
		($host,$port)=split (":",$host);
		$port=80 if ($port eq ""); #     ,   80  
		
		$AF_INET=($] > 5 ? AF_INET : 2);
		$SOCK_STREAM=($] > 5 ? SOCK_STREAM: 1);
		$protocol=(getprotobyname('tcp'))[2];
		$addr=(gethostbyname($host))[4];
		$addrs=pack ('S n a4 x8', $AF_INET, $port, $addr);
		socket(LOAD,$AF_INET,SOCK_STREAM,$protocol);
		connect(LOAD, $addrs);
		binmode (LOAD);
		select(LOAD); $|=1; select(STDOUT);
		#  
		print LOAD "GET ${get} HTTP/1.0\r\n";
		print LOAD "User-Agent: X-Uploader v1.0 (SatanStation)\r\n";
		print LOAD "Accept: */*\r\n";
		print LOAD "Range: bytes=0-\r\n";
		print LOAD "Host: $host\r\n\r\n";

		select (undef, undef, undef, .25);
		#   
		open (SWAP, ">swap");
		binmode (SWAP);
		binmode (STDOUT);
		
		sysread (LOAD, $what, 2048);
	    $what=~/\r?\n\r?\n/s;
	    $what=$';
		print SWAP $what;
		
		while (sysread (LOAD, $what, 2048)){
			print SWAP $what;
		}
		close (SWAP);
		close (LOAD);

		$ftp->type("I");
		$ftp->put("swap", "$FORM{ftpdir}/${dfile}");
		
	} else{
		$url=$file;
		$url=~s /ftp:\/\///;
		($host,@info)=split ("/",$url);
		$dfile=$info[$#info];
		$info="/".join ("/", @info);
						
		$ftpl=Net::FTP->new ($host);
		$ftpl->login ('anonymous', 'some@some.ru');
		$ftpl->type("I");
		$ftpl->get("${info}", "swap");
		$ftp->type("I");
		$ftp->put("swap", "$FORM{ftpdir}/${dfile}");
		$ftpl->quit();
	}
}

print "OK!";
$ftp->quit();
unlink ("swap");



sub parse_form{
	read (STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	@pairs=split (/&/, $buffer);
	foreach $pair (@pairs){
		($name,$value) = split (/=/,$pair);
		$value=~ tr/+/ /;
		$value=~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
		$FORM{$name}=$value;
	}
}

